//
//  Utils.swift
//  GameBattleshipTerminal
//
//  Created by Piotr Fulmański on 2019.10.04.
//  Copyright © 2019 Piotr Fulmański. All rights reserved.
//

import Foundation

class Utils {
    // Also can be implemented as an extension
    class func determineNumberOfDigits(number: Int) -> Int {
        var value = 10
        
        for digits in 1...10 {
            if (value>number) {
                return digits
            }
            value *= 10
        }
        
        return 0
    }
    
    class func getRandomInt(from: Int, to: Int, excluding: [Int]? = nil) -> Int {
        let maxTries = 10
        var candidate = -1
        
        if from == to {
            return from
        }
        
        for _ in 0 ..< maxTries {
            candidate = Int.random(in: from ... to)
            
            if excluding != nil {
                if !excluding!.contains(candidate) {
                    return candidate
                }
            } else {
                return candidate
            }
        }
        
        return candidate
    }
}
