//
//  main.swift
//  GameBattleshipTerminal
//
//  Created by Piotr Fulmański on 2019.10.04.
//  Copyright © 2019 Piotr Fulmański. All rights reserved.
//

import Foundation

let shipsSize = [4, 3, 3, 2, 2, 2, 1, 1, 1, 1]
let game = EngineGameBattleship(shipsSize: shipsSize)
let opponentReady = game.shipsAutoSetup(shipsSize: shipsSize, maxTriesPerShip: 20, who: EngineGameBattleship.Who.opponent)
let playerReady = game.shipsAutoSetup(shipsSize: shipsSize, maxTriesPerShip: 20, who: EngineGameBattleship.Who.player)
var whoseTurn = EngineGameBattleship.Who.player
var row, col: Int
var coordinates: (row: Int, col: Int)?

game.printBoards()

if opponentReady, playerReady {
    while(true){
        print("\n\n\n TURN")
        print(whoseTurn)
        
        if whoseTurn == EngineGameBattleship.Who.player {
            coordinates = game.getShootCoordinatesForPlayer()
            if coordinates == nil {
                print("Player can't shoot")
                break
            } else {
                print("Shoot at row \(coordinates!.row) and column \(coordinates!.col)")
            }
            game.shot(who: whoseTurn, row: coordinates!.row, col: coordinates!.col)
            whoseTurn = EngineGameBattleship.Who.opponent
        } else {
            coordinates = game.getShootCoordinatesForOpponent(maxTries: 100)
            if coordinates == nil {
                print("Opponent can't shoot")
                break
            } else {
                print("Shoot at row \(coordinates!.row) and column \(coordinates!.col)")
           }
            game.shot(who: whoseTurn, row: coordinates!.row, col: coordinates!.col)
            whoseTurn = EngineGameBattleship.Who.player
        }
        
        game.printBoards()
        if let who = game.checkWhoWins() {
            print("The winner is \(who)")
            break
        }
    }
} else {
    print("Can't arrange all ships")
}


